namespace javaCamViewer
{
    using System;
    using System.IO;
    using System.Net;

    /// <summary>
    /// MainMod
    /// </summary>
    public class MainMod
    {
        public static bool cameraDecoderControl(int cmd, String host, String query)
        {
            const String cmdUrl = "http://{0}/decoder_control.cgi{1}&command={2}";

            if (cmd < 0) return false;
            if (!query.StartsWith("?")) query = "?" + query;

            try
            {
                WebRequest req = WebRequest.Create(String.Format(cmdUrl, host, query, cmd));
                req.Credentials = CredentialCache.DefaultCredentials;

                WebResponse resp = req.GetResponse();
                Stream inStream = resp.GetResponseStream();
                StreamReader reader = new StreamReader(inStream);
                String responseFromServer = reader.ReadToEnd();
                reader.Close();
                resp.Close();

                return responseFromServer.Contains("ok.");
            }
            catch
            {
                return false;
            }
        }

        public static bool cameraCameraControl(String param, String value, String host, String query)
        {
            const String cmdUrl = "http://{0}/camera_control.cgi{1}&param={2}&value={3}";

            if (!query.StartsWith("?")) query = "?" + query;

            try
            {
                WebRequest req = WebRequest.Create(String.Format(cmdUrl, host, query, param, value));
                req.Credentials = CredentialCache.DefaultCredentials;

                WebResponse resp = req.GetResponse();
                Stream inStream = resp.GetResponseStream();
                StreamReader reader = new StreamReader(inStream);
                String responseFromServer = reader.ReadToEnd();
                reader.Close();
                resp.Close();

                return responseFromServer.Contains("ok.");
            }
            catch
            {
                return false;
            }
        }

        public static bool hitUrl(String url)
        {
            try
            {
                WebRequest req = WebRequest.Create(url);
                req.Credentials = CredentialCache.DefaultCredentials;

                WebResponse resp = req.GetResponse();
                Stream inStream = resp.GetResponseStream();
                StreamReader reader = new StreamReader(inStream);
                String responseFromServer = reader.ReadToEnd();
                reader.Close();
                resp.Close();

                return true;
            }
            catch
            {
                return false;
            }
        }

        public static String formatBytes(double number)
        {
            String[] unim = new String[] {"B", "Kb", "Mb", "Gb", "Tb", "Pb"};
            int c = 0;

            while (number >= 1024)
            {
                c++;
                number /= 1024;
            }

            return Math.Round(number, (c != 0 ? 2 : 0)).ToString() + " " + unim[c];
        }

        public static String getResourceString(String sResName)
        {
            try
            {
                return javaCamViewer.Properties.Resources.ResourceManager.GetObject(sResName).ToString();
            }
            catch
            {
                return "";
            }
        }

    }
}
